;;;quick hack for renaming %glFoo functions
;;; (based on older name mangling code, so doesn't handle all the cases
;;;  the CL code does, but good enough for the stuff used in cl-opengl)

 (defvar *fix%gl-old-prefix* "%gl")

 (defvar *fix%gl-new-prefix* "%gl:")

 (defvar *fix%gl-special-case-list* 
  `((,(concat *fix%gl-old-prefix* "End") . 
     ,(concat *fix%gl-new-prefix* "end"))
    (,(concat *fix%gl-old-prefix* "IsEnabled") . 
     ,(concat *fix%gl-new-prefix* "is-enabled"))
    (,(concat *fix%gl-old-prefix* "Rects") .
     ,(concat *fix%gl-new-prefix* "rect-s"))
    (,(concat *fix%gl-old-prefix* "Rectsv") . 
     ,(concat *fix%gl-new-prefix* "rect-sv"))
    (,(concat *fix%gl-old-prefix* "Indexs") . 
     ,(concat *fix%gl-new-prefix* "index-s"))
    (,(concat *fix%gl-old-prefix* "Indexsv") . 
     ,(concat *fix%gl-new-prefix* "index-sv"))
    (,(concat *fix%gl-old-prefix* "PushAttrib") . 
     ,(concat *fix%gl-new-prefix* "push-attrib"))
    (,(concat *fix%gl-old-prefix* "PushClientAttrib") . 
     ,(concat *fix%gl-new-prefix* "push-client-attrib"))
    (,(concat *fix%gl-old-prefix* "PopAttrib") . 
     ,(concat *fix%gl-new-prefix* "pop-attrib"))
    (,(concat *fix%gl-old-prefix* "PopClientAttrib") . 
     ,(concat *fix%gl-new-prefix* "pop-client-attrib"))
    (,(concat *fix%gl-old-prefix* "GetActiveAttrib") . 
     ,(concat *fix%gl-new-prefix* "get-active-attrib"))
    (,(concat *fix%gl-old-prefix* "GetBooleanv") . 
     ,(concat *fix%gl-new-prefix* "get-boolean-v"))
    (,(concat *fix%gl-old-prefix* "GetIntegerv") . 
     ,(concat *fix%gl-new-prefix* "get-integer-v"))
    (,(concat *fix%gl-old-prefix* "GetFloatv") . 
     ,(concat *fix%gl-new-prefix* "get-float-v"))
    (,(concat *fix%gl-old-prefix* "GetDoublev") . 
     ,(concat *fix%gl-new-prefix* "get-double-v"))
    (,(concat *fix%gl-old-prefix* "GetPointerv") . 
     ,(concat *fix%gl-new-prefix* "get-double-v"))
))

;; (assoc* "glEnd" *fix%gl-special-case-list* :test 'string=)

 (defun fix%gl-suffix (name)
  (replace-regexp-in-string
   "\\([a-z][a-tv-z]\\)\\(\\(?:b\\|i\\|f\\|d\\|ub\\|us\\|ui\\)v?\\|[0-9]+\\)$"
   "\\1-\\2"
   name))

 (defun fix%gl (name) 
  (if (assoc* name *fix%gl-special-case-list* :test 'string=)
      (cdr (assoc* name *fix%gl-special-case-list* :test 'string=))
      (downcase 
       (fix%gl-suffix
        (setq name 
              (let ((case-fold-search nil))
                (replace-regexp-in-string 
                 "\\([a-z]\\)\\([0-9]\\|[A-Z]\\)" "\\1-\\2"
                 (replace-regexp-in-string
                  (regexp-quote *fix%gl-old-prefix*)
                  *fix%gl-new-prefix*
                  name)
                 t)))))))

;;; M-C-% %gl[A-Z]\w+ RET \,(fix%gl \&) RET